package Net::Paraget::Mirror;
#
# $Id: Mirror.pm,v 1.1.1.1 2001/01/31 19:40:39 ftobin Exp $
#

use strict;
use Carp;

use URI;

use Net::Paraget::Server;

use Class::MethodMaker
  get_set       => [ qw( type url ) ],
  boolean       => [ qw( disabled ) ],
  new_hash_init => 'hash_init',
  new_with_init => 'new';


sub init
{
    my ( $self, $url ) = @_;
    
    $self->url( URI->new( $url ) );
}


sub server_id
{
    my ( $self ) = @_;
    
    carp "cannot determine server because url is not set"
      unless $self->url();
    
    return Net::Paraget::Server->new( host   => $self->url->host(),
				   scheme => $self->url->scheme(),
				 )->as_string();
}


sub as_string
{
    my ( $self ) = @_;
    $self->url();
}

1;
