package Net::Paraget::ServerList;
#
# $Id: ServerList.pm,v 1.1.1.1 2001/01/31 19:40:39 ftobin Exp $
#

use strict;

use Class::MethodMaker
  hash          => [ qw( servers ) ],
  new_hash_init => 'new';


sub read_in_servers
{
    # eventually this will read in previously-stored stats about servers
    return;
}


sub count_servers
{
    my ( $self ) = @_;
    return scalar $self->servers_keys();
}


sub average_speed
{
    my ( $self ) = @_;
    return $self->get_average( 'speed' );
}


sub average_overhead
{
    my ( $self ) = @_;
    return $self->get_average( 'overhead' );
}


sub get_average
{
    my ( $self, $value ) = @_;

    my $n = $self->count_servers() or return undef;
    my $sum = 0;

    foreach my $s ( $self->servers_values() )
    {
       my $x = $s->$value();
       $sum += $x if defined $x;
    }

    my $average = int ( $sum / $n );
    return $average;
}      
                                  
sub get_a
{
    my ( $self, $value ) = @_;
    my $average_string = "average_$value";
    my $default_string = "default_$value";
    
    my $a = ( $self->$value()
	      || $self->list->$average_string()
	      || $self->list->$default_string()
	    );
    return $a;
}


sub a_speed
{
    my ( $self ) = @_;
    return $self->get_a( 'speed' );
}


sub an_overhead
{
    my ( $self ) = @_;
    return $self->get_a( 'overhead' );
}


sub default_speed
{
    return 10**3;
}


sub default_overhead
{
    return 3;
}

1;
